﻿using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Layouts;
using ArcGIS.Desktop.Mapping;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace DockpaneAndProWindowDemos
{
	internal class Module1 : Module
	{
		private static Module1 _this = null;

		internal static readonly object _lock = new object();


		private ObservableCollection<string> _features = new ObservableCollection<string>();


		/// <summary>
		/// Retrieve the singleton instance to this module here
		/// </summary>
		public static Module1 Current => _this ??= (Module1)FrameworkApplication.FindModule("DockpaneAndProWindowDemos_Module");

		public ObservableCollection<string> FeatureInfo => _features;

		#region Overrides
		/// <summary>
		/// Called by Framework when ArcGIS Pro is closing
		/// </summary>
		/// <returns>False to prevent Pro from closing, otherwise True</returns>
		protected override bool CanUnload()
		{
			//TODO - add your business logic
			//return false to ~cancel~ Application close
			return true;
		}

		#endregion Overrides

		internal void ZoomToBookmark(string bookmarkName)
		{
			QueuedTask.Run(() =>
			{
				var bookmark = MapView.Active.Map.GetBookmarks().First(b => b.Name == bookmarkName);
				MapView.Active.ZoomTo(bookmark);
			});
		}

	}
}
